
piboxwww - Bug #285
Implement authentication for the web interface
08 Mar 2014 16:35 - Hammel

Status: Closed Start date: 08 Mar 2014
Priority: Immediate Due date:
Assignee: Hammel % Done: 100%
Category: Settings Estimated time: 0.00 hour
Target version: 0.10.0
Severity: 01 - Critical
Description

Not sure if this should be php or javascript.  But I need a login and session authentication via the web interface.

Associated revisions
Revision 5e7da23d - 03 Dec 2014 21:59 - Hammel

RM #285: Add AUTH support to monkey using a default user.

Revision e2f7ee91 - 05 Dec 2014 14:04 - Hammel

RM #285: Implemented test for admin password change, including a new password set page and the ability to send a new MT_PW message to piboxd
to handle the password update.

Revision 1ffa6757 - 05 Dec 2014 16:26 - Hammel

RM #285: Fix POST var name for pw.

Revision 1e8f0c8e - 05 Dec 2014 16:33 - Hammel

RM #285: Set the action bit for MA_SAVE.

Revision 772c66f6 - 05 Dec 2014 17:18 - Hammel

RM #285: Added MT_PW and associated actions to diagram.

Revision 3648ae43 - 05 Dec 2014 17:19 - Hammel

RM #285: Added support for MT_PW and associated actions for changing a user password in the web service.

Revision e5235ca9 - 05 Dec 2014 17:25 - Hammel

RM #285: Remove creation of DEFAULT file.  This is superceded by piboxd handling.

Revision e0238c82 - 05 Dec 2014 17:26 - Hammel
RM #285: Extend the artificial delay after updating a password before reloading the front page.

Revision 5b1d66ea - 06 Dec 2014 11:52 - Hammel

RM #285: Cleaned up icons to more closely match the ones used on the attached display (under launcher) and added users icon to front page.

Revision 60c24734 - 06 Dec 2014 14:02 - Hammel

RM #285: Don't include the xcf files in the images directory of the packaging.

Revision c8f6484d - 06 Dec 2014 21:28 - Hammel

RM #285: comment update to reflect actual code for MT_PW, MA_GET.

Revision d0163a3d - 07 Dec 2014 21:54 - Hammel

RM #285: add support for MA_GET to MT_PW.

Revision a935dc9d - 07 Dec 2014 21:55 - Hammel

RM #285: Move check for payload to MA_SAVE only (MA_GET doesn't need it) in handlePW.  Also, make sure cleanup is properly handled for the
socket descriptor in handlePW.

Revision f71b9647 - 08 Dec 2014 12:00 - Hammel

RM #285: Integrated a user selection page that allows creating, updating and deleting users.

Revision a810e2a8 - 08 Dec 2014 12:13 - Hammel

RM #285: Retrieving from a text input field with jquery requires use of val().

Revision 60143cc5 - 08 Dec 2014 12:13 - Hammel

RM #285: Add usersPW.js script to support saving changes.

Revision c01a0e24 - 08 Dec 2014 14:49 - Hammel

RM #285: Add support for deleting a user.

Revision b5425129 - 08 Dec 2014 15:12 - Hammel

RM #285: Add missing "!" when checking for delete parameter.
Revision d4d3376a - 08 Dec 2014 15:13 - Hammel

RM #285: Added support for MT_PW/MA_DEL to delete a user.

Revision 7baeba4b - 08 Dec 2014 19:58 - Hammel

RM #285: Add support for creating a log file on installation and disable logging by default.

Revision c1812618 - 16 Dec 2014 11:22 - Hammel

RM #285: Added user and camera icons for use with the web interface.

History
#1 - 08 Mar 2014 20:53 - Hammel
Research:
    -  Designing a Secure REST (Web) API without OAuth
    -  PHP Tutorials : User Authentication Tutorials
    -  HTTP Basic and Digest authentication with PHP
    -  HTTP Authentication with HTML Forms

#2 - 06 May 2014 20:54 - Hammel
- Priority changed from Urgent to Normal
- Target version changed from 0.9.0 to 0.10.0

Moving configuration tools to 0.10.0.

#3 - 11 Sep 2014 10:01 - Hammel
- Priority changed from Normal to Immediate

#4 - 03 Dec 2014 17:47 - Hammel
- Status changed from New to In Progress
- % Done changed from 0 to 20

Authentication with Monkey overrides adding authentication with PHP, Javascript or HTTP headers.  That's because Monkey doesn't provide the usual
authentication.

See the monkey documentation for details on how to set up basic authentication.

I think this means I'll set up an initial authentication and then add a Users tab to the web interface to add users, set passwords and restart monkey. 
That should be about it.

#5 - 03 Dec 2014 18:16 - Hammel
- % Done changed from 20 to 30
http://www.thebuzzmedia.com/designing-a-secure-rest-api-without-oauth-authentication/
http://www.tutorialized.com/tutorials/PHP/User-Authentication/1
http://evertpot.com/223/
http://www.peej.co.uk/articles/http-auth-with-html-forms.html
http://monkey-project.com/documentation/basic_authentication


A quick tests of this shows that it's easy to setup and works fine.  Here is what need to happen.

    1. Add the Basic Auth configuration to the monkey opkg.
    2. Create a default user with a default password in user.mk
    3. frontpage.php needs to test if the default user has been modified.
        1. If not, force the user to change the default user password.
    4. Create a new page called from frontpage with a new "users" icon.
    5. The user page will allow editing existing users and adding new users
        1. Find existing users: pull from first column of users.mk file
        2. Updated passwords: use mk_passwd -b
    6. If a password is changed then monkey has to be restarted.  
        1. Schedule the restart for a second or two after the update
        2. This gives us time to return to the main page first.
        3. Restart could be a new command for piboxd: delay (int, milliseconds), command are the payload

#6 - 03 Dec 2014 22:14 - Hammel

Auth config added to monkey with default admin user.

Now I need to make the changes to frontpage.php to test if the admin user pw needs to be changed.

#7 - 05 Dec 2014 14:07 - Hammel
- % Done changed from 30 to 40

Implemented test for admin password change, including a new password set page and the ability to send a new MT_PW message (message type = 4,
which is not yet implemented in piboxed) to piboxd to handle the password update.

Now I need to implement the password change request in piboxd.

After that I need to go back and add the new users page that allows selecting a user and then calls the userPW.tmple like frontpage does for changing
the users password.

#8 - 05 Dec 2014 14:07 - Hammel
- Project changed from PiBox to piboxwww
- Category deleted (04 - Root File System)

#9 - 05 Dec 2014 14:08 - Hammel
- Category set to Settings
- Severity changed from 03 - Medium to 01 - Critical

#10 - 05 Dec 2014 17:34 - Hammel
- % Done changed from 40 to 50

Implemented password change requirement for first login for the admin user.  Tested on target and seems to work quite well.

All changes committed and pushed.

Now I need to add a users page (with a front page icon) that allows adding and deleting users (except the admin) and changing their passwords.
http://monkey-project.com/documentation/basic_authentication


#11 - 06 Dec 2014 11:59 - Hammel
- % Done changed from 50 to 60

I updated the web icons to match the style used in the launcher and added a users icon.

Now I need the users page and functionality.  Note that the piboxd action for getting users is already implemented (MT_PW, MA_GET).

#12 - 08 Dec 2014 12:18 - Hammel
- % Done changed from 60 to 80

With the exception of deleting users (which requires another action added to MT_PW in piboxd), this functionality is complete.  You can now edit
existing users and add new ones.

Deleting a user should be pretty easy so I'll wait till I finish that before closing this issue.

#13 - 08 Dec 2014 15:45 - Hammel
- Status changed from In Progress to Closed
- % Done changed from 80 to 100

Added delete functionality.  Code tested, committed and pushed.

Closing issue
